local _, class = UnitClass("player")
if class ~= "DEATHKNIGHT" then
    return;
end

local RPText = CreateFrame("frame")

RP_DB = {
    x = 0;
    y = -100;
    size = 15;
    unlocked = false;
};

local color, mana, percent = "FFFFFF", mana, percent --Define some locals
local options, opttitle, optslider, optfonttitle, optlock
local pf = CreateFrame("Frame", "RP_PlayerFrame", UIParent)
local pt = pf:CreateTexture(nil, "BACKGROUND")
local pp = pf:CreateFontString("RPT_PlayerPower", "ARTWORK", "GameFontNormalHuge")
pf:SetFrameStrata("MEDIUM")

--[[Fix UIScale placements
local effScale = pf:GetEffectiveScale()
local left, bottom = pf:GetLeft(), pf:GetBottom()
local storel, storeb = effScale/left, effScale/bottom
local parentscale = UIParent:GetScale()
local restorel, restoreb = parentscale*left, parentscale*bottom]]

function RPText_OnLoad(self)
    self:RegisterEvent("UNIT_RUNIC_POWER")
    self:RegisterEvent("ADDON_LOADED")
    RPText:SetScript("OnEvent", RPText_OnEvent)
    RPText:SetScript("OnUpdate", RPText_Font)
end

local timer = 10
function RPText_Font(self, elapsed)
    timer = timer - elapsed
    if timer < 0 then
        if IsAddOnLoaded("tekticles") then
            pp:SetFont(STANDARD_TEXT_FONT, RP_DB.size)
        else
            pp:SetFont("Fonts\\FRIZQT__.TTF", RP_DB.size)
        end
        self:SetScript("OnUpdate", nil)
    end
end

function RPText_UpdatePower()    
    if (percent >= 80) then --green
        pp:Show();
        color = "00CD00"
    elseif (percent < 80 and percent >= 40) then --yellow
        pp:Show();
        color = "FFFF00"
    elseif (percent < 40 and percent >= 20) then -- orange
        pp:Show();
        color = "FF6600"
    elseif (percent < 20 and percent >= 4) then --red
        pp:Show();
        color = "FF0033"
    elseif (UnitMana("player") == 0) then --hide
        pp:Hide();
    else
        pp:Hide();
    end
    
    pp:SetText("|cFF"..color..UnitMana("player").."|r")
    --print("|cff00CD00"..pf:GetFormattedText("$c", UnitMana("player"), UnitManaMax("player")).."|r")
    --Create the text and it's color
end

function RPText_OnEvent(self, event, arg1, ...)
    if (event == "UNIT_RUNIC_POWER") then
        mana = (UnitManaMax("player") / UnitMana("player")) --Used to find the percent of Runic Power
        percent = (100 / mana)
        RPText_UpdatePower();
    elseif (event == "ADDON_LOADED" and arg1 == "RPText") then
        RPText_BlizzOptions();
        
        pf:SetFrameStrata("BACKGROUND")
        pf:SetFrameLevel(0)
        pf:SetWidth(50)
        pf:SetHeight(50)
        pf:Show();
        
        pp:SetPoint("CENTER", pf)
        pp:SetText("|cffffffffRP|r")
        pp:Show();
        
    
        if RP_DB.x then
            pf:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", RP_DB.x, RP_DB.y)
        else
            pf:SetPoint("CENTER", UIParent)
        end
        if not RP_DB.size then
            RP_DB.size = 15;
        end
    end
end

function Size_ValueChanged(self, value)
    RP_DB.size = value;
    if IsAddOnLoaded("tekticles") then
        pp:SetFont(STANDARD_TEXT_FONT, RP_DB.size)
    else
        pp:SetFont("Fonts\\FRIZQT__.TTF", RP_DB.size)
    end
    optfonttitle:SetText(math.floor(optslider:GetValue()*10) / 10)
end

function RPText_UnLock(self)
    if self then
        RP_DB.unlocked = self:GetChecked()
    end
    if RP_DB.unlocked then
        pt:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
        pt:SetAllPoints(pf)
        pf:SetFrameLevel(5)
        pf:SetFrameStrata("DIALOG")
        pf:SetMovable(true)
        pf:EnableMouse(true)
        pf:RegisterForDrag("LeftButton")
        pf:SetClampedToScreen(true)
        pf:SetScript("OnDragStart", pf.StartMoving)
        pf:SetScript("OnDragStop", function(pf) pf:StopMovingOrSizing();
        RP_DB.x, RP_DB.y = pf:GetLeft(), pf:GetBottom() end)
    else
        pt:SetTexture(nil)
        pf:SetFrameLevel(0)
        pf:SetFrameStrata("MEDIUM")
        pf:SetMovable(false)
        pf:EnableMouse(false)
    end
end

function RPText_BlizzOptions()
    options = CreateFrame("frame", "RPText_Options", UIParent);
    options.name = "RPText";
    options:SetWidth(300);
    options:SetHeight(200);
    
    opttitle = options:CreateFontString("RPTitle", "ARTWORK", "GameFontNormalHuge")
    opttitle:SetText("RPText Options")
    opttitle:SetPoint('TOP', options, 'TOP', -95, -10)
    --Scale slider
    optslider = CreateFrame("Slider", "FontSlider", options, "OptionsSliderTemplate")
    optslider:SetMinMaxValues(15, 40)
    optslider:SetValueStep(1)
    optslider:SetWidth(160)
    getglobal('FontSliderLow'):SetText("Small")
    getglobal('FontSliderHigh'):SetText("Large")
    --Scale value string
    optfonttitle = options:CreateFontString("optScale", "ARTWORK", "GameFontNormal")
    optfonttitle:SetText(RP_DB.size)
    optfonttitle:SetPoint("BOTTOM", optslider, "BOTTOM", 0, -10)
    optslider:SetScript('OnShow', function(self) self:SetValue(RP_DB.size) end)
    optslider:SetScript('OnValueChanged', Size_ValueChanged)
    optslider:SetPoint('CENTER', options, 'CENTER', 0, 20)
    
    --Checkbox (Lock/Unlock)
    optlock = CreateFrame("CheckButton", "RPText_FrameLock", options, "OptionsCheckButtonTemplate");
    _G[optlock:GetName().."Text"]:SetText("Unlock Frame")
    optlock:SetScript('OnShow', function(self) self:SetChecked(RP_DB.unlocked) end)
    optlock:SetScript('OnClick', RPText_UnLock)
    optlock:SetPoint('BOTTOM', optslider, 'BOTTOM', 0, -40)
    
    InterfaceOptions_AddCategory(options);
end

SlashCmdList["RPTEXT"] = function(msg)
    RPText_SlashHandler(string.lower(msg));
end

SLASH_RPTEXT1 = "/rptext"
SLASH_RPTEXT2 = "/rpt"

function RPText_SlashHandler(msg)
    InterfaceOptionsFrame_OpenToCategory(options);
end

RPText_OnLoad(RPText)